Graphics3D 640,480

;creates masked sprites of the correct size
;use as include file
;include version of sprite_maker

Dim rgb(200,50)

Function new_sprite(mes$,imhandle=0,sptype=0)

;either plain text or image

If sptype=0
mwid=StringWidth(mes$)
mhigh=StringHeight(mes$)
EndIf

If sptype=1
mwid=ImageWidth(imhandle)
mhigh=ImageHeight(imhandle)
;DebugLog mwid
;DebugLog mhigh
EndIf

spimage=CreateImage(mwid,mhigh)

SetBuffer ImageBuffer(spimage)

If sptype=0
Text 0,0,mes$
EndIf

If sptype=1
DrawImage imhandle,0,0
EndIf


LockBuffer

For j=0 To mwid-1
For k=0 To mhigh-1
rgb(j,k)=ReadPixelFast(j,k)
Next
Next

UnlockBuffer


sptexture=CreateTexture(mwid,mhigh,4)

maskit(sptexture,0)

sprite=CreateSprite()

EntityTexture sprite,sptexture

width#=mwid
height#=mhigh

scover#=256
;If sptype=1 Then scover=32

ScaleSprite sprite,width/scover,height/scover

SetBuffer BackBuffer()

Return(sprite)

End Function



Function maskit(texture,rsource=0)

Local darklimit=64

SetBuffer TextureBuffer(texture)

LockBuffer

For xx=0 To TextureWidth(texture)-1
For yy=0 To TextureHeight(texture)-1

If rsource=0 Then rst=rgb(xx,yy) ;for textures on the fly
If rsource=1 Then rst=ReadPixelFast(xx,yy) ;for global textures

uu=rst 
uu=uu+(2 Shl 23)
b=uu Mod 256
uu=uu/256
g=uu Mod 256
uu=uu/256
r=uu Mod 256


do_mask=0
;If rst=-(2 Shl 23) Then do_mask=1
;If rsource=0 Then darklimit=1
If r<darklimit And g<darklimit And b<darklimit Then do_mask=1

If do_mask=1
WritePixelFast xx,yy,$00000000
Else
WritePixelFast xx,yy,rst
EndIf

Next
Next


UnlockBuffer

End Function